{puts, inspect}= require 'sys'
{_} = require 'underscore'
stitch= require './stitch' # Using a local version of stitch
uglify= require 'uglify-js'
eco= require 'eco'
fs= require 'fs'

options=
  quiet:    no
  compress: no

say= (msg)-> puts msg unless options.quiet

set_options= (opts)->  options= _.extend options, opts

compress_js= (source, callback)->
  compressed_source = if options.compress
    jsp= uglify.parser
    pro= uglify.uglify
    ast= jsp.parse(source)
    ast= pro.ast_mangle(ast)
    ast= pro.ast_squeeze(ast)
    pro.gen_code(ast)
  else
    source
  callback compressed_source

_(exports).extend

  js: (paths, callback)->
    package = stitch.createPackage 
      paths: paths
      compilers:
        eco: (module, filename)->
          content= fs.readFileSync filename
          template = eco.compile(content.toString())
          module._compile template, filename
    
    package.compile (err, js)->
      if err
        callback err, null 
      else
        compress_js js, (final_js)->
          callback no, final_js

  css: (path, callback)->
    package = stitch.createCssPackage 
      paths: [path]
    
    package.compile (err, css)->
      callback err, css

  
  setOptions: (opts)->
    set_options opts

  compressJs: (source, callback)->
    compress_js source, callback
