# Build tools requirements
#  - Node.js (+ NPM... If I were you, anyway...)
#  - CoffeeScript
#  - LessCSS
#  - Eco Templates
#  - Underscore
#  - UglifyJS (for compression)

{puts, inspect}= require 'sys'
{_} = require 'underscore'
fs= require 'fs'

builder= require './builder'
server= require './server'

options=
  quiet: no
  compress:   no

# Helpers

say= (msg)-> puts msg unless options.quiet
set_options= (opts)->  
  options= _.extend options, opts
  builder.setOptions opts
  server.setOptions opts


_.extend exports,

  say: say
  builder: builder
  server: server
 
  setOptions: (opts)->
    set_options opts
  

  buildJs: (output, paths..., opts)->
    set_options opts
    builder.js paths, (err, js)->
      if err
        say "!!! #{err}"
      else
        fs.writeFileSync output, js
        say " - #{output}"

  buildCss: (output, path, opts)->
    set_options opts
    builder.css path, (err, css)->
      if err
        say "!!! #{err}"
      else
        fs.writeFileSync output, css
        say " - #{output}"
  
  
  test: (opts)->
    set_options opts
    invoke 'build' # Assumes a build task?
    process.chdir __dirname
    {reporters} = require 'nodeunit'
    reporters.default.run ['test']
    
