{_} = require 'underscore'
{puts, inspect}= require 'sys'
build= require './builder'
express= require('express')
staticProvider= require 'connect/middleware/staticProvider'

options=
  quiet: no
  port: 3000
  js_uri: '/app.js'
  js_path: ['lib']
  css_uri: '/app.css'
  css_path: ['styles']

say= (msg)-> puts msg unless options.quiet
set_options= (opts)->  options= _.extend options, opts

js_response= (jsPaths)->
  (req, res, next)->
    build.js jsPaths, (err, js)->
      if err
        res.writeHead 500, 'Content-Type': 'text/plain'
        res.send err
        puts "Server error:"
        puts err
        puts ""
      else
        res.header 'Content-Type', 'text/javascript'
        res.send js

css_response= (cssPath)->
  (req, res, next)->
    build.css cssPaths, (err, css)->
      if err
        res.writeHead 500, 'Content-Type': 'text/plain'
        res.send err
        puts "Server error:"
        puts err
        puts ""
      else
        res.header 'Content-Type', 'text/css'
        res.send css


_(exports).extend

  createDevServer: (opts)->
    set_options opts
    app= express.createServer()
    app.use(staticProvider( root:options.root, cache:no, maxAge:1 )) 
    if options.js_uri
      app.get options.js_uri, js_response _([options.js_path]).flatten()
    if options.css_uri
      app.get options.css_uri, css_response _([options.css_path]).flatten()
    app

  jsResponder: js_response
  cssResponder: css_response
    
  setOptions: (opts)-> set_options opts